#include "SDL_V8.h"
#include "engine.h"

#ifndef _WIN32
//#include <X11/Xlib.h>
#endif

#if SDL_BYTEORDER == SDL_BIG_ENDIAN
//this is not possible on proper platforms
//Except MIPS?
//You got this running on MIPS, I wanna know.
#else
	const unsigned int Fbmask = 0x000000ff;
	const unsigned int Fgmask = 0x0000ff00;
	const unsigned int Frmask = 0x00ff0000;
	const unsigned int Famask = 0xff000000;
#endif

int SCREENWIDTH = 300;
int SCREENHEIGHT = 240;

int MIN_SCREENWIDTH = 300;
int MIN_SCREENHEIGHT = 240;

void TendEvents(){
	    	SDL_PollEvent( &event );
	if(!(event.type==SDL_QUIT))
	{
			SDL_PeepEvents(&event, 1, SDL_ADDEVENT, SDL_ALLEVENTS);
	    	SDL_PollEvent( &event );
    }
    else{
    		SDL_PeepEvents(&event, 1, SDL_ADDEVENT, SDL_ALLEVENTS);
			QuitGracefully;
    }
}

void PrintSDLInfo(){
            if(SDL_WasInit(SDL_FLAGS)==(SDL_FLAGS)){
            const SDL_VideoInfo *VideoInfo = SDL_GetVideoInfo();
            const SDL_version *SDL_Version = SDL_Linked_Version();
            printf("SDL Version:                  %i.%i.%i\n", SDL_Version->major,SDL_Version->minor,SDL_Version->patch);
            printf("Hardware Surfaces Available:  %i\n", VideoInfo->hw_available);
            printf("Image blits accelerated:      %i\n", VideoInfo->blit_hw);
            printf("Surface blits accelerated:    %i\n", VideoInfo->blit_sw);
            printf("Image Alpha accelerated:      %i\n", VideoInfo->blit_hw_A);
            printf("Surface Alpha accelerated:    %i\n", VideoInfo->blit_sw_A);
            printf("Color Fill acclerated:        %i\n", VideoInfo->blit_fill);
            printf("Available Video Memory:       %iK\n",VideoInfo->video_mem);
            }
            else{
                printf("SDL was not initialized.\n");
            }

            printf("SDL Has detected the following extensions:\n\t");

            int n = 0;

            INFO_SAY(SDL_HasRDTSC,    "RDTSC",      n);
            INFO_SAY(SDL_HasMMX,      "MMX",        n);
            INFO_SAY(SDL_HasMMXExt,   "MMX Ext",    n);
            INFO_SAY(SDL_Has3DNow,    "3DNow!",     n);
            INFO_SAY(SDL_Has3DNowExt, "3DNow! Ext", n);
            INFO_SAY(SDL_HasSSE,      "SSE",        n);
            INFO_SAY(SDL_HasSSE2,     "SSE2",       n);
            INFO_SAY(SDL_HasAltiVec,  "Altivec",    n);

            printf("\n");

            printf("Reported Video Driver:\n\t");

            char namebuf[32];

            SDL_VideoDriverName(namebuf, 32);

            printf(namebuf);

            printf("\n");

            if(TTF_WasInit()){
            const SDL_version *TTF_Version = TTF_Linked_Version();
                printf("SDL_TTF Version:              %i.%i.%i\n", TTF_Version->major,TTF_Version->minor,TTF_Version->patch);
            }
            else{
                printf("SDL_TTF was not initialized.\n");
            }

            if(true){

            const SDL_version *IMG_Version = IMG_Linked_Version();
            printf("SDL_Image Version:            %i.%i.%i\n", IMG_Version->major,IMG_Version->minor,IMG_Version->patch);
            }
            else{
                printf("SDL_Image was not initialized.\n");
            }

            const SDL_version *MIX_Version = Mix_Linked_Version();
            printf("SDL_Mixer Version:            %i.%i.%i\n", MIX_Version->major,MIX_Version->minor,MIX_Version->patch);
            int audio_rate = 0;
            Uint16 audio_format = 0;
            int audio_channels = 0;

            Mix_QuerySpec(&audio_rate, &audio_format, &audio_channels);

            std::string format_desc = "";
            bool knownformat = true;
            switch(audio_format){
            case AUDIO_U8:
            format_desc = "Unsigned 8-bit samples";
            break;
            case AUDIO_S8:
            format_desc = "Signed 8-bit samples";
            break;
            case AUDIO_U16LSB:
            format_desc = "Unsigned 16-bit samples";
            break;
            case AUDIO_S16LSB:
            format_desc = "Signed 16-bit samples";
            break;
            case AUDIO_U16MSB:
            format_desc = "Signed 16-bit samples (big-endian)";
            break;
            case AUDIO_S16MSB:
            format_desc = "Unsigned 16-bit samples (big endian)";
            break;
            default:
            knownformat = false;
            }

            printf("Audio rate:                   %i\n", audio_rate);
            printf("Audio format:                 %s", format_desc.c_str());
            if(!knownformat){
                printf("%x", audio_format);
            }
            printf("\n");
            printf("Default number of channels:   %i\n", audio_channels);
}

SDL_Rect cmpltscreen = {0, 0, (Uint16)SCREENWIDTH, (Uint16)SCREENHEIGHT};

SDL_Event event;
SDL_Surface *screen = NULL;

void QuitAll(){
    SDL_VideoQuit();
    IMG_Quit();
    TTF_Quit();
    Mix_CloseAudio();
    SDL_Quit();
    exit(0);
}
