#ifndef V8_SDL_HEAD
#define V8_SDL_HEAD
#include <string>
#include <math.h>
#include "stdafx.h"
#include "TS.h"
#if defined _WIN32
#include "v8.h"
#include "SDL/SDL.h"
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_audio.h"
#include "SDL/SDL_mixer.h"
#include "SDL/SDL_thread.h"
#endif

#ifndef _WIN32

#include "v8.h"
#include "/usr/include/SDL/SDL.h"
#include "/usr/include/SDL/SDL_ttf.h"
#include "/usr/include/SDL/SDL_image.h"
#include "/usr/include/SDL/SDL_audio.h"
#include "/usr/include/SDL/SDL_mixer.h"
#include "/usr/include/SDL/SDL_thread.h"
#endif

//void exitContext(void);

#define QuitGracefully \
    printf("Exiting TurboSphere...\n");\
    QuitAll();

#if SDL_BYTEORDER == SDL_BIG_ENDIAN
//this is not possible on proper platforms
//Except MIPS?
//You got this running on MIPS, I wanna know.
#else
	extern const unsigned int Frmask;
	extern const unsigned int Fgmask;
	extern const unsigned int Fbmask;
	extern const unsigned int Famask;
#endif

#define IMG_FLAGS (IMG_INIT_JPG|IMG_INIT_PNG|IMG_INIT_TIF)
#define MIX_FLAGS (MIX_INIT_OGG)
#define SDL_FLAGS SDL_INIT_AUDIO|SDL_INIT_VIDEO|SDL_INIT_TIMER
#define SDL_VIDEO_FLAGS SDL_HWSURFACE|SDL_ASYNCBLIT|SDL_DOUBLEBUF|SDL_HWACCEL

#define BPP 4
#define DEPTH 32

#define CHANNEL_MASKS Frmask, Fgmask, Fbmask, Famask

extern int SCREENWIDTH;
extern int SCREENHEIGHT;
extern int MIN_SCREENWIDTH;
extern int MIN_SCREENHEIGHT;

	extern SDL_Rect cmpltscreen;

	extern SDL_Event event;
	extern SDL_Surface *screen;

    int EventHandlerInit();
    int EventHandle(void *);

    void TendEvents();

    void PrintSDLInfo();

    void QuitAll();

#define INFO_SAY(check, speech, n) \
    if (check()) { \
        if(n>0){\
            printf(", ");\
        }\
        n++;\
        printf(speech);\
    }

#define CHECK_ARG_INT(index, name) \
    if (!args[index]->IsNumber()) { \
        return v8::ThrowException(v8::String::New(name));\
    }

#define CHECK_ARG_STR(index, name) \
    if (!args[index]->IsString()) { \
        return v8::ThrowException(v8::String::New(name));\
    }

#define CHECK_ARG_OBJ(index, name) \
    if (!args[index]->IsObject()) { \
        return v8::ThrowException(v8::String::New(name));\
    } \

#define CHECK_ARG_BOOL(index, name) \
    if (!args[index]->IsBoolean()) { \
        return v8::ThrowException(v8::String::New(name));\
    } \

#define CHECK_ARG_ARRAY(index, name) \
    if (!args[index]->IsArray()) { \
        return v8::ThrowException(v8::String::New(name));\
    } \

#endif
