#include "functionload.h"
#include <cstring>

#ifdef _WIN32
#define STRDUP _strdup
#else
#define STRDUP strdup
#endif

regFunction::regFunction(char *_name, v8::Handle<v8::FunctionTemplate> _templ){
    name = STRDUP(name);
	templ = _templ;
}

std::vector<regFunction> funclist;

int registerfunction(char *name, v8::Handle<v8::Value> (*func)(const v8::Arguments& args)){
    if(!func){
        return 1;
    }
    if(name==NULL){
        return 1;
    }
    regFunction newfunc(name, v8::FunctionTemplate::New(*func));
    funclist.push_back(newfunc);
    return 0;
}

regFunction::regFunction(char *name, v8::Handle<v8::Value> (*func)(const v8::Arguments& args)){
    name    = STRDUP(name);
    templ   = v8::FunctionTemplate::New(*func);
}

regFunction::~regFunction(){
}

void regFunction::registerToContext(v8::Persistent<v8::Context> context){
    context->Global()->Set(v8::String::New(name), templ->GetFunction());
}


int registerFuncsFromDL(const int numfuncs, v8::Handle<v8::Value> (*funcs[])(const v8::Arguments& args), char * names[], v8::Persistent<v8::Context> context){

    for(int i = 0; i<numfuncs; i++){
        regFunction *tempfunc = new regFunction(names[i], funcs[i]);
        tempfunc->registerToContext(context);
    }
	return 0;
}
