#include "SDL_V8.h"
v8::Handle<v8::Value> GetMouseX(const v8::Arguments& args)
{
	SDL_PumpEvents();
	int x = 0;
	SDL_GetMouseState(&x, NULL);
	return v8::Int32::New(x);
}

v8::Handle<v8::Value> GetMouseY(const v8::Arguments& args)
{
	SDL_PumpEvents();
	int	y = 0;
	SDL_GetMouseState(NULL, &y);
	return v8::Int32::New(y);
}

v8::Handle<v8::Value> IsMouseButtonPressed(const v8::Arguments& args)
{
	if(args.Length()<1||args[0]->Int32Value()>6){return v8::Undefined();}
	SDL_PumpEvents();
	return v8::Boolean::New(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(args[0]->Int32Value()+1));
}

void TS_SetMouseConstants(v8::Persistent<v8::Context> context){
	context->Global()->Set(v8::String::New("MOUSE_LEFT"),  v8::Number::New(0));

	context->Global()->Set(v8::String::New("MOUSE_MIDDLE"),  v8::Number::New(1));

	context->Global()->Set(v8::String::New("MOUSE_RIGHT"),  v8::Number::New(2));

	context->Global()->Set(v8::String::New("MOUSE_SUP"),  v8::Number::New(3));

	context->Global()->Set(v8::String::New("MOUSE_SDOWN"),  v8::Number::New(4));

	context->Global()->Set(v8::String::New("MOUSE_SDIS"),  v8::Number::New(5));
}
