#include <iostream>
#include <fstream>
#include "SDL_V8.h"
#include "opengame.h"
#include "t5.h"

using namespace std;

TS_Config TS_conf;

TS_Directories TS_dirs;

void setDirectories(string basedirectory){
        TS_dirs.image       = string(TS_dirs.root).append("images/");
        TS_dirs.font        = string(TS_dirs.root).append("fonts/");
        TS_dirs.script      = string(TS_dirs.root).append("scripts/");
        TS_dirs.sound       = string(TS_dirs.root).append("sounds/");
        TS_dirs.map         = string(TS_dirs.root).append("maps/");
        TS_dirs.other       = string(TS_dirs.root).append("other/");
        TS_dirs.save        = string(TS_dirs.root).append("save/");
        TS_dirs.spriteset   = string(TS_dirs.root).append("spritesets/");
        TS_dirs.animation   = string(TS_dirs.root).append("animations/");
        TS_dirs.windowstyle = string(TS_dirs.root).append("windowstyles/");
        TS_dirs.system      = "system/";
        TS_dirs.systemscript= "system/scripts";
        T5_init(2, "", TS_dirs.root.c_str());
}

void setConfig(string basedirectory){
    T5_file *enginefile = T5_OpenFile("engine.ini");
    TS_conf.fullscreen = (atoi(enginefile->getValueFromSection("fullscreen", "Video"))>0)?true:false;

    T5_file *systemfile = T5_OpenFile(string(TS_dirs.system).append("system.ini").c_str());

    TS_conf.systemfont          = systemfile->getValue("Font");
    TS_conf.systemttffont       = systemfile->getValue("TTFFont");
    TS_conf.systemwindowstyle   = systemfile->getValue("WindowStyle");
	printf("These words mean T5 is working: %s\n", TS_conf.systemwindowstyle);
    TS_conf.systemarrow         = systemfile->getValue("Arrow");
    TS_conf.systemuparrow       = systemfile->getValue("UpArrow");
    TS_conf.systemdownarrow     = systemfile->getValue("DownArrow");
    T5_close(enginefile);
    T5_close(systemfile);

}

void opengame(const char *Rfile)
{
    TS_conf.soundchannels = 32;
	printf("Opening SGM file %s\n", Rfile);
	printf("base dir: %s\n", TS_dirs.root.c_str());
    string txt;
    std::ifstream file(Rfile, std::ios_base::in);
    if (file.is_open())
		while (file.good()){
            getline(file, txt);
			if(!txt.empty()){
				//const char *line = txt.c_str();
				size_t nameloc=txt.find("name");
				size_t scriloc=txt.find("script");
				size_t scwiloc=txt.find("screen_width");
				size_t scheloc=txt.find("screen_height");

				if(nameloc!=string::npos&&int(nameloc)<2){
					TS_conf.gamename = txt.substr(nameloc+5, 128);
				}
				else if(scriloc!=string::npos&&int(scriloc)<2){
					TS_conf.mainscript = string(TS_dirs.script).append(txt.substr(scriloc+7, 128));
					//printf("%s\n", TS_conf.mainscript.c_str());
				}
				else if(scwiloc!=string::npos&&int(scwiloc)<2){
					SCREENWIDTH = atoi(txt.substr(scwiloc+13, 128).c_str());
					//printf("Setting screen width to  %i\n", SCREENWIDTH);
				}
				else if(scheloc!=string::npos&&int(scheloc)<2){
					SCREENHEIGHT = atoi(txt.substr(scheloc+14, 128).c_str());
					//printf("Setting screen height to  %i\n", SCREENHEIGHT);
				}

			}
		}
	else {printf("game.sgm is not readable");}
		cmpltscreen.w=SCREENWIDTH;
		cmpltscreen.h=SCREENHEIGHT;

    file.close();
}
