#ifndef T5_HEAD
#define T5_HEAD

#include <iostream>
#include <fstream>
#include <vector>

class INIvalue{
public:
    INIvalue(const char*,const char*,const char*);
    const char *key;
    const char *val;
    const char *sec;
};

class T5_file{
public:
	T5_file(const char *);
	T5_file();
	~T5_file();
    bool good();
    const char* getValueFromSection(const char*, const char*);
    const char* getValue(const char*);
    void writeValue(const char *, const char *);
    void writeValueToSection(const char *, const char*, const char*);
    void flush(void);
private:
	std::fstream stream;
	std::vector<INIvalue*> values;
};

#ifndef _win32

extern "C" void T5_AddDir(const char *dir);
extern "C" T5_file *T5_OpenFile(const char*);
extern "C" void T5_init(int ndirs, ...);
extern "C" void T5_close(T5_file*);

#endif

#endif
