#include "SDL_V8.h"
#include "windowstyle.h"
#include "opengame.h"

	v8::Persistent<v8::FunctionTemplate> WindowStyletempl;//  = *v8::FunctionTemplate::New();
	v8::Persistent<v8::ObjectTemplate> WindowStyleInsttempl;//= *Fonttempl->InstanceTemplate();
    v8::Persistent<v8::ObjectTemplate> WindowStyleproto;//    = *Fonttempl->PrototypeTemplate();

void WindowStyleInit(){
    WindowStyletempl    = *v8::FunctionTemplate::New();
	WindowStyleInsttempl= *WindowStyletempl->InstanceTemplate();
    WindowStyleproto    = *WindowStyletempl->PrototypeTemplate();
    WindowStyleproto->Set("drawWindow", v8::FunctionTemplate::New(TS_WSdrawWindow));

}

void WindowStyleClose(){
    WindowStyletempl.Dispose();
	WindowStyleInsttempl.Dispose();
    WindowStyleproto.Dispose();
}

void TS_WindowStyleFinalizer(v8::Persistent<v8::Value> object, void* parameter) {
    TS_WindowStyle* ws = (TS_WindowStyle*)parameter;
    delete ws;
    object.Dispose();
}

TS_WSborder::TS_WSborder(SDL_Surface *im){
    image = SDL_ConvertSurface(im, im->format, im->flags);
    width = image->w;
    height = image->h;
    mask = TS_Color(0,0,0,0);
}

TS_WSborder::TS_WSborder(){
    image = new SDL_Surface;
    width = 0;
    height= 0;
    mask = TS_Color(0,0,0,0);
}

TS_WScorner::TS_WScorner(SDL_Surface *im, int xOff, int yOff){
    image = SDL_ConvertSurface(im, im->format, im->flags);
    width = image->w;
    height = image->h;
    xOffset = xOff;
    yOffset = yOff;
}

TS_WScorner::TS_WScorner(){
    image = new SDL_Surface;
    width = 0;
    height= 0;
    xOffset = 0;
    yOffset = 0;
    mask = TS_Color(0,0,0,0);
}

SDL_Surface *TS_WindowStyle::getImage(int num){
    switch(num){
        case 0:
        return upperleft.image;
        case 1:
        return top.image;
        case 2:
        return upperright.image;
        case 3:
        return right.image;
        case 4:
        return lowerright.image;
        case 5:
        return bottom.image;
        case 6:
        return lowerleft.image;
        case 7:
        return left.image;
        default:
        return upperleft.image;
    }
return new SDL_Surface;
}

TS_WindowStyle::TS_WindowStyle(const char *file){

	SDL_RWops *wsfile;
	wsfile = SDL_RWFromFile(file, "rb");
    if(!wsfile){
		printf("Could not open file %s\n", file);   //the file should be checked BEFORE passing it to the constructor!
	}
    unsigned char   sig[5]    = "    ";
	unsigned short  version[1];
	unsigned char   edge_width[1];
	unsigned char   background_mode[1];
	unsigned char   corner_color_comp[16];
    unsigned char   edge_offsets[4];

	//sig
    SDL_RWread(wsfile, sig, 1,4);

    //version
    SDL_RWread(wsfile, version, 2,1);

    //edge width
    SDL_RWread(wsfile, edge_width, 1,1);

    //background mode
    SDL_RWread(wsfile, background_mode, 1,1);

    //corner colors
    SDL_RWread(wsfile, corner_color_comp, 1,16);

    //edge offsets
    SDL_RWread(wsfile, edge_offsets, 1,4);

	SDL_RWseek(wsfile, 64, SEEK_SET);

    if(version[0]==1){

    }
    if(version[0]==2){
        unsigned short dimensions[2];
        for(int i = 0; i<8; i++){
            SDL_RWread(wsfile, dimensions, 2, 2);
        switch(i){
            case 0:
                CREATE_WS_COMPONENT(upperleft.image, dimensions[0], dimensions[1]);
                break;
            case 1:
                CREATE_WS_COMPONENT(top.image, dimensions[0], dimensions[1]);
                break;
            case 2:
                CREATE_WS_COMPONENT(upperright.image, dimensions[0], dimensions[1]);
                break;
            case 3:
                CREATE_WS_COMPONENT(right.image, dimensions[0], dimensions[1]);
                break;
            case 4:
                CREATE_WS_COMPONENT(lowerright.image, dimensions[0], dimensions[1]);
                break;
            case 5:
                CREATE_WS_COMPONENT(bottom.image, dimensions[0], dimensions[1]);
                break;
            case 6:
                CREATE_WS_COMPONENT(lowerleft.image, dimensions[0], dimensions[1]);
                break;
            case 7:
                CREATE_WS_COMPONENT(left.image, dimensions[0], dimensions[1]);
                break;
            default:
                CREATE_WS_COMPONENT(upperleft.image, dimensions[0], dimensions[1]);
                break;
        }
        }
    }

}

TS_WindowStyle::~TS_WindowStyle(){

}

void TS_WindowStyle::drawWindow(int x, int y, int w, int h){

    for(int i = 0; i<8; i++){
        SDL_Surface *imageptr = this->getImage(i);
        if(i%2==0){
            SDL_Rect rect = {(short int)((i%3>0)?w+x:x-imageptr->w), (short int)((i>3)?h+y:y-imageptr->h), (short unsigned int)(imageptr->w), (short unsigned int)(imageptr->h)};
            SDL_BlitSurface(imageptr, NULL, screen, &rect);
        }
        else if(i==1||i==5){
            int curX = 0;
            while(curX<w){
                SDL_Rect src = {0, 0, (short unsigned int)(((w-curX)>(imageptr->w))?imageptr->w:w-curX), (short unsigned int)(imageptr->h)};
                SDL_Rect dest;
                if(i==1){
                    dest.x  = x+curX;
                    dest.y  = y-imageptr->h;
                    dest.w  = imageptr->w;
                    dest.h  = imageptr->h;
                }
                else{
                    dest.x  = x+curX;
                    dest.y  = h+y;
                    dest.w  = imageptr->w;
                    dest.h  = imageptr->h;
                }
                SDL_BlitSurface(imageptr, &src, screen, &dest);
                curX+=imageptr->w;
            }
        }
        else{
            int curY = 0;
            while(curY<h){
                SDL_Rect src    = {0, 0, (short unsigned int)(imageptr->w), (short unsigned int)(((h-curY)>(imageptr->h))?imageptr->h:h-curY)};
                SDL_Rect dest;
                if(i==3){
                    dest.x  = x+w;
                    dest.y  = y+curY;
                    dest.w  = imageptr->w;
                    dest.h  = imageptr->h;

                }
                else{

                    dest.x  = x-imageptr->w;
                    dest.y  = y+curY;
                    dest.w  = imageptr->w;
                    dest.h  = imageptr->h;
                }
                SDL_BlitSurface(imageptr, &src, screen, &dest);
                curY+=imageptr->h;
            }
        }

    }

}


TS_WSborder::~TS_WSborder(){
SDL_FreeSurface(image);
}

TS_WScorner::~TS_WScorner(){
SDL_FreeSurface(image);
}

v8::Handle<v8::Value> LoadWindowStyle(const v8::Arguments& args) {
    if(args.Length()<1){
        return v8::ThrowException(v8::String::New("LoadWidnowStyle Error: Called with no arguments."));
    }
    CHECK_ARG_STR(0, "LoadWidnowStyle Error: Arg 0 is not a string.");
    v8::HandleScope loadWindowStylescope;
	v8::Handle<v8::Value> external;
    TS_WindowStyle *ws = NULL;
    if (args[0]->IsExternal()) {
        external = v8::Local<v8::External>::Cast(args[0]);
    }
    else{
        v8::String::Utf8Value str(args[0]);
        const char *wsname = *str;

        SDL_RWops *wstest = SDL_RWFromFile(string(TS_dirs.windowstyle).append(wsname).c_str(), "rb");
        if(!wstest){
            SDL_RWclose(wstest);
            printf("TS: Could not open rws file %s\n", wsname);
            return v8::ThrowException(v8::String::New(string("LoadWidnowStyle Error: Could not load windowstyle ").append(wsname).c_str()));
        }
        SDL_RWclose(wstest);

        ws = new TS_WindowStyle(string(TS_dirs.windowstyle).append(wsname).c_str());

        external = v8::External::New(ws);
    }

  	WindowStyleInsttempl->SetInternalFieldCount(1);
	v8::Local<v8::Function> WindowStylector = WindowStyletempl->GetFunction();
	v8::Local<v8::Object> WindowStyleobj = WindowStylector->NewInstance();
    v8::Persistent<v8::Object> PWindowStyleobj = v8::Persistent<v8::Object>::New(WindowStyleobj);
    PWindowStyleobj.MakeWeak(ws, TS_WindowStyleFinalizer);
	PWindowStyleobj->SetInternalField(0, external);
    return loadWindowStylescope.Close(PWindowStyleobj);
}

v8::Handle<v8::Value> GetSystemWindowStyle(const v8::Arguments& args) {

    v8::HandleScope loadWindowStylescope;
	v8::Handle<v8::Value> external;
        const char *wsname = string(TS_dirs.system).append(TS_conf.systemwindowstyle).c_str();

        SDL_RWops *wstest = SDL_RWFromFile(wsname, "rb");
        if(!wstest){
            SDL_RWclose(wstest);
            return v8::ThrowException(v8::String::New(string("GetSystemWindowStyle Error: Could not load windowstyle ").append(wsname).c_str()));
        }
        SDL_RWclose(wstest);

       TS_WindowStyle *ws = new TS_WindowStyle(string(TS_dirs.system).append(TS_conf.systemwindowstyle).c_str());

        external = v8::External::New(ws);


  	WindowStyleInsttempl->SetInternalFieldCount(1);
	v8::Local<v8::Function> WindowStylector = WindowStyletempl->GetFunction();
	v8::Local<v8::Object> WindowStyleobj = WindowStylector->NewInstance();
    v8::Persistent<v8::Object> PWindowStyleobj = v8::Persistent<v8::Object>::New(WindowStyleobj);
    PWindowStyleobj.MakeWeak(ws, TS_WindowStyleFinalizer);
	PWindowStyleobj->SetInternalField(0, external);
    return loadWindowStylescope.Close(PWindowStyleobj);
}


v8::Handle<v8::Value> TS_WSdrawWindow(const v8::Arguments& args) {

	if(args.Length()<4){
        return v8::ThrowException(v8::String::New("TS_WSdrawWindow Error: called with less than 3 parameters."));
    }
    CHECK_ARG_INT(0, "TS_WSdrawWindow Error: could not parse arg 0 to number.")
    CHECK_ARG_INT(1, "TS_WSdrawWindow Error: could not parse arg 1 to number.")
    CHECK_ARG_INT(2, "TS_WSdrawWindow Error: could not parse arg 2 to number.")
    CHECK_ARG_INT(3, "TS_WSdrawWindow Error: could not parse arg 3 to number.")

	int x = static_cast<int>(args[0]->NumberValue());
	int y = static_cast<int>(args[1]->NumberValue());
	int w = static_cast<int>(args[2]->NumberValue());
	int h = static_cast<int>(args[3]->NumberValue());
	//const char * z = args[2]->AsciiValue();
	v8::Local<v8::Object> self = args.Holder();
	//v8::Local<v8::External> wrap = v8::Local<v8::External>::Cast(self->GetInternalField(0));

	static_cast<TS_WindowStyle*>(v8::Local<v8::External>::Cast(self->GetInternalField(0))->Value())->drawWindow(x,y,w,h);
    //delete font;
    self.Clear();
    //wrap.Clear();

	return v8::Undefined();
}
