#ifndef WS_HEAD
#define WS_HEAD
#include "graphic.h"

class TS_WSborder{
    public:
    TS_WSborder(SDL_Surface *);
    TS_WSborder();
    ~TS_WSborder();
    int width;
    int height;
    SDL_Surface *image;
    TS_Color mask;
};
class TS_WScorner{
    public:
    TS_WScorner(SDL_Surface *, int, int);
    TS_WScorner();
    ~TS_WScorner();
    int width;
    int height;
    int xOffset;
    int yOffset;
    SDL_Surface *image;
    TS_Color mask;
};

class TS_WindowStyle{
    public:
    TS_WindowStyle(const char*);
    ~TS_WindowStyle();
    TS_WSborder top;
    TS_WSborder right;
    TS_WSborder bottom;
    TS_WSborder left;
    TS_WScorner upperleft;
    TS_WScorner upperright;
    TS_WScorner lowerright;
    TS_WScorner lowerleft;
    TS_Color cornerColors[4];
    char edge_offsets[4];
    TS_Color mask;
    SDL_Surface *getImage(int);
    void drawWindow(int, int, int, int);
};

    v8::Handle<v8::Value> LoadWindowStyle(const v8::Arguments& args);
    v8::Handle<v8::Value> GetSystemWindowStyle(const v8::Arguments& args);
    v8::Handle<v8::Value> TS_WSdrawWindow(const v8::Arguments& args);


	extern v8::Persistent<v8::FunctionTemplate> WindowStyletempl;//  = *v8::FunctionTemplate::New();
	extern v8::Persistent<v8::ObjectTemplate> WindowStyleInsttempl;//= *Fonttempl->InstanceTemplate();
    extern v8::Persistent<v8::ObjectTemplate> WindowStyleproto;//    = *Fonttempl->PrototypeTemplate();

void WindowStyleInit();
void WindowStyleClose();

//Macro for creating WindowStyle components.

#define CREATE_WS_COMPONENT(component, w, h) \
        component = SDL_CreateRGBSurface(SDL_HWSURFACE|SDL_SRCALPHA, w, h, DEPTH, Fbmask, Fgmask, Frmask, Famask);\
        SDL_RWread(wsfile, component->pixels, BPP, w*h);
#endif
